<?php
/**
 * JBZoo App is universal Joomla CCK, application for YooTheme Zoo component
 *
 * @package     jbzoo
 * @version     2.x Pro
 * @author      JBZoo App http://jbzoo.com
 * @copyright   Copyright (C) JBZoo.com,  All rights reserved.
 * @license     http://jbzoo.com/license-pro.php JBZoo Licence
 * @coder       Denis Smetannikov <denis@jbzoo.com>
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

?> <script type="text/javascript">
var elweightarr = [];
</script><?php

$db = JFactory::getDBO();
$curuser =& JFactory::getUser();
$session = JFactory::getSession();
$userbonus = $session->get('userbonus', '0', 'jbzoo');

$query = $db->getQuery(true);
$query->select("SUM(bonus) as bonus");
$query->from('#__user_bonus');
$query->where("((user_id = '".$curuser->id."') AND (bonus_date < '".date('Y-m-d')."') AND (active = '1'))");
$db->setQuery((string)$query);
$result = $db->loadObject();
$totalbonus = $result->bonus;

$query = $db->getQuery(true);
$query->select("SUM(bonusminus) as bonusminus");
$query->from('#__user_bonus');
$query->where("((user_id = '".$curuser->id."') AND (active = '1'))");
$db->setQuery((string)$query);
$result = $db->loadObject();
$totalbonus -= $result->bonusminus;
$bonuscanuse = 0;

$view = $this->getView();
$this->app->jbassets->basket();
$this->app->jbassets->initJBPrice();
?>
<p style="text-align:right">У Вас: <?php echo $totalbonus ?> бонусов.</p>
<table class="jbbasket-table jsJBZooBasket">
    <thead>
    <tr>
        <th>#</th>
        <th><?php echo JText::_('JBZOO_CART_ITEM_SKU'); ?></th>
        <th></th>
        <th><?php echo JText::_('JBZOO_CART_ITEM_NAME'); ?></th>
        <th style="min-width: 70px;"><?php echo JText::_('JBZOO_CART_ITEM_PRICE'); ?></th>
        <th><?php echo JText::_('JBZOO_CART_ITEM_QUANTITY'); ?></th>
        <th><?php echo JText::_('JBZOO_CART_ITEM_SUBTOTAL'); ?></th>
        <th></th>
    </tr>
    </thead>

    <tbody>
    <?php
    $i = 0;
    $summa = 0;
    $count = 0;
	$totalweight = 0;

    $currencyConvert = $view->appParams->get('global.jbzoo_cart_config.currency');
    $imageElementId = $view->appParams->get('global.jbzoo_cart_config.element-image');

    foreach ($view->basketItems as $hash => $basketItem) {

        $item = $basketItem['item'];

        $basketItem['price'] = $this->app->jbmoney->convert($basketItem['currency'], $currencyConvert, $basketItem['price']);

        $count += $basketItem['quantity'];

        $subtotal = $basketItem['quantity'] * $basketItem['price'];
        $summa += $subtotal;

		$curelement = $item->getElement('b0d2b218-87a9-4573-85b7-350d2eec1061');
		$data = (array)$curelement->data();	
		if ($data['basic']['discount'] == 0) $bonusclass = "hasbonus";
		else $bonusclass = "";
		
		$elementweight = $item->getElement('1a81724a-b570-4f7f-9bca-27781a86013b');
		$data2 = (array)$elementweight->data();
		$weight = $data2['0']['value'];
		$totalweight += $weight * $basketItem['quantity'];
		?>
        <script type="text/javascript">
			elweightarr[<?php echo $i ?>] = <?php echo $weight ?>;
		</script>
        <?php
        $image = $this->app->jbitem->renderImageFromItem($item, $imageElementId, true);

        echo '<tr class="row-' . $hash . '" data-itemId="' . $item->id . '" data-hash="' . $hash . '">';
        echo '<td>' . ++$i . '</td>';
        echo '<td>' . $basketItem['sku'] . '</td>';
        echo '<td>' . $image . '</td>';

        echo '<td>';
        echo '<a href="' . $this->app->route->item($item) . '" title="' . $item->name . '">' . $item->name . '</a>';

        if (isset($basketItem['priceParams']) && !empty($basketItem['priceParams'])) {
            foreach ($basketItem['priceParams'] as $key => $value) {
                if (!empty($value)) {
                    echo '<div><strong>' . $key . ':</strong> ' . $value . '</div>';
                }
            }
        }

        if (!empty($basketItem['priceDesc'])) {
            echo '<br/><span class="price-description">' . $basketItem['priceDesc'] . '</span>';
        }

        echo " Вес: ".$weight.'</td>';

        if ($basketItem['price']) {
            echo '<td class="jsPricevalue" price="' . $basketItem['price'] . '">'
                . $this->app->jbmoney->toFormat($basketItem['price'], $currencyConvert)
                . ' </td>';
        } else {
            echo '<td> - </td>';
        }

        echo '<td><input type="text" class="jsQuantity input-quantity" value="' . $basketItem['quantity'] . '" /></td>';

        if ($basketItem['price']) {
            echo '<td class="jsSubtotal '.$bonusclass.'">' . $this->app->jbmoney->toFormat($subtotal, $currencyConvert) . '</td>';
        } else {
            echo '<td> - </td>';
        }

        echo '<td><input type="button" class="jbbutton jsDelete" itemid="' . $item->id . '" value="' . JText::_('JBZOO_CART_DELETE') . '" /></td>';
        echo "</tr>\n";
    }
	$summa20 = $summa * 0.2;
	if ($summa20 > 10) {
		if ($summa20 >= $totalbonus) $bonuscanuse = $totalbonus;
		else  {
			$bonuscanuse = intval($summa20 / 10) * 10;
		}
	}
    ?>
    </tbody>

    <tfoot>
    <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td><strong><?php echo JText::_('JBZOO_CART_TOTAL'); ?>:</strong></td>
        <td class="jsTotalCount"><?php echo $count; ?></td>
        <td class="jsTotalPrice"><?php echo $this->app->jbmoney->toFormat($summa, $currencyConvert); ?></td>
        <td>
            <input type="button" class="jbbutton jsDeleteAll" value="<?php echo JText::_('JBZOO_CART_REMOVE_ALL'); ?>"/>
        </td>
    </tr>
    <tr>
		<td colspan="4">&nbsp;</td>
       	<td id="tdbonuscanuse" colspan="3"><strong>Использовать <?php echo $bonuscanuse ?> бонусов</strong></td>
        <td><center><input type="checkbox" id="bonuscheckbox" name="bonuscheckbox"  onclick="applybonus()" <?php if ($userbonus > 0) {echo "checked=\"checked\"";} ?>/></center></td>
	</tr>
    <tr>
		<td colspan="4">&nbsp;</td>
       	<td id="tddeliverytext" colspan="2"><strong>Стоимость доставки</strong></td>
        <td id="tddelivery" colspan="2">0 р.</td>
	</tr>
    <tr>
		<td colspan="4">&nbsp;</td>
       	<td colspan="2"><strong>Общий вес (кг)</strong></td>
        <td id="tdweight" colspan="2"><?php echo $totalweight ?></td>
	</tr>
    <tr>
		<td colspan="4">&nbsp;</td>
       	<td id="tdbonuscanuse" colspan="2"><strong>ИТОГО</strong></td>
        <td id="tditogo" colspan="2"><?php echo $this->app->jbmoney->toFormat($summa, $currencyConvert); ?></td>
	</tr>
    </tfoot>
</table>

<script type="text/javascript">
    jQuery(function ($) {
        $('.jbzoo .jsJBZooBasket').JBZooBasket({
            'clearConfirm': "<?php echo JText::_('JBZOO_CART_CLEAR_CONFIRM');?>",
            'quantityUrl' : "<?php echo $this->app->jbrouter->basketQuantity($view->appId);?>",
            'deleteUrl'   : "<?php echo $this->app->jbrouter->basketDelete($view->appId);?>",
            'clearUrl'    : "<?php echo $this->app->jbrouter->basketClear($view->appId);?>"
        });
    });
	
	var userbonus = <?php echo $userbonus ?>;
	var totalbonus = <?php echo $totalbonus ?>;
	var summa20 = 0;
	var bonuscanuse = 0;
	var totalsum = 0;
	var newtotalsum = 0;
	var factpaid = 0;
	var bonussumm = 0;
	var deliverytype1 = "";
	var deliverytype2 = "";
	var itogo = 0;
	var delivery = 0;
	var weight = 0;
	var emsstat = "";
	var emsprice = 0;
	var emsmin = 0;
	var emsmax = 0;
		
	function countbonus() {
		totalsum = parseFloat(jQuery("#jbzoo td.jsTotalPrice").html().replace(/ р./, '').replace(/,/, '.').replace(/ /, ''));
		summa20 = round(totalsum * 0.2,2);
		bonuscanuse = 0;
		if (summa20 > 10) {
			if (summa20 >= totalbonus) bonuscanuse = totalbonus;
			else {
				bonuscanuse = parseInt(summa20 / 10) * 10;
			}
		}
		jQuery("#tdbonuscanuse").html("<strong>Использовать " + bonuscanuse + " бонусов</strong>");
		return bonuscanuse;
	}
	
	function applybonus() {
		weight = 0;
		jQuery('.hasbonus').each(function(i, el) { bonussumm += parseFloat(jQuery(el).html().replace(/ р./, '').replace(/,/, '.').replace(/ /, '')); });
		jQuery('#jbzoo input.input-quantity').each(function(i, el) { weight += round(elweightarr[i] * parseFloat(jQuery(el).val()),3); });
		
		deliverytype1 = jQuery('select[name="elements[37d3a0c7-9446-48ff-a0a1-7476aef328b8][0][list-0]"] option:selected').val();
		deliverytype2 = jQuery('select[name="elements[37d3a0c7-9446-48ff-a0a1-7476aef328b8][0][list-1]"] option:selected').val();
		
		if (jQuery("#bonuscheckbox").prop("checked")) {	
			userbonus = countbonus();
			newtotalsum = round(totalsum - bonuscanuse,2);		
		} else {
			totalsum = parseFloat(jQuery("#jbzoo td.jsTotalPrice").html().replace(/ р./, '').replace(/,/, '.').replace(/ /, ''));
			newtotalsum = totalsum;
			userbonus = 0;
		}
		
		switch (deliverytype1) {
			case "Самовывоз"           : {jQuery("#tddelivery").html("0 р."); delivery = 0; jQuery("#tddeliverytext").html("<strong>Стоимость доставки</strong>"); break;}
			case "Доставка курьером"   : {jQuery("#tddeliverytext").html("<strong>Стоимость доставки</strong>");					
										  switch (deliverytype2) {
case "Доставка по г. Самара"                                                                   : {

	if (newtotalsum > 2000) {jQuery("#tddelivery").html("0 р."); delivery = 0;}
	else {jQuery("#tddelivery").html("150 р."); delivery = 150;};
	break;}
case "п.Запанской, п.Мясокомбинат,Зубчаниновка от ул.Магистральной до поста ДПС"               : {jQuery("#tddelivery").html("200 р."); delivery = 200; break;}
case "п.Красная Глинка, п.Сухая Самарка, п.Мехзавод, п.Управленческий, 116-й км, п.Смышляевка" : {jQuery("#tddelivery").html("350 р."); delivery = 350; break;}
case "с.Красный Яр, с.Малая Царевщина, п.Волжский"                                             : {jQuery("#tddelivery").html("680 р."); delivery = 680; break;}
case "г.Кинель, с.Курумоч"               													   : {jQuery("#tddelivery").html("765 р."); delivery = 765; break;}
case "г.Тольятти"              																   : {jQuery("#tddelivery").html("1 400 р."); delivery = 1400; break;}
case "г.Отрадный, г.Жигулевск"      												           : {jQuery("#tddelivery").html("1 600 р."); delivery = 1600; break;}
case "г.Нефтегорск"         															       : {jQuery("#tddelivery").html("1 760 р."); delivery = 1760; break;}
case "г.Сергиевск"         															 	       : {jQuery("#tddelivery").html("2 050 р."); delivery = 2050; break;}
case "г.Сызрань"         																       : {jQuery("#tddelivery").html("2 900 р."); delivery = 2900; break;}
default                                   												       : {jQuery("#tddelivery").html("0 р."); delivery = 0; break;}
										  }; break;}
			case "Доставка почтой ЕМС" : {delivery = 0; applyems(weight); break;}
			default                    : {jQuery("#tddelivery").html("0 р."); delivery = 0; break;}
		};
		itogo = newtotalsum + delivery;
		jQuery("#tditogo").html(itogo + " р.");
		jQuery("#tdweight").html(round(weight,3));

		jQuery.ajax({
   			type: "POST",
			url: "index.php?option=com_zoo&controller=basket&task=setbonus",
			data: "userbonus=" + userbonus + "&bonussumm=" + bonussumm + "&factpaid=" + newtotalsum + "&deliverysum=" + delivery,
			dataType: 'html',
			async: false
 		});
	}

	function round(a,b) {
 		b=b || 0;
 		return Math.round(a*Math.pow(10,b))/Math.pow(10,b);
	}
	
	function applyems(weight) {
		if (deliverytype1 == "Доставка почтой ЕМС") {
			from = "city--samara";
			to = "city--" + jQuery('select[name="elements[fe492a91-951e-4e06-9054-3df8af796f8a][option][]"] option:selected').val();
		
			jQuery.ajax({
	   			type: "GET",
				url: "http://emspost.ru/api/rest?method=ems.calculate&from=" + from + "&to=" + to + "&weight=" + weight + "",
				dataType: 'jsonp',
				crossDomain: true,
				async: false,
				success: function(data){
					emsstat = data.rsp.stat;
					if (emsstat == "ok") {
						emsprice = data.rsp.price;
						emsmin = data.rsp.term.min;
						emsmax = data.rsp.term.max;
						jQuery("#tddeliverytext").html("<strong>Стоимость доставки</strong><br />от " + emsmin + " до " + emsmax + " дней");
						jQuery("#tddelivery").html(emsprice + " р.");
						itogo = parseFloat(newtotalsum) + parseFloat(emsprice);
						jQuery("#tditogo").html(itogo + " р.");			
						jQuery.ajax({
							type: "POST",
							url: "index.php?option=com_zoo&controller=basket&task=setbonus",
							data: "userbonus=" + userbonus + "&bonussumm=" + bonussumm + "&factpaid=" + newtotalsum + "&deliverysum=" + emsprice,
							dataType: 'html',
							async: false
						});
					} else {
						alert("При обращении к серверу EMS произошла ошибка!   (" + data.rsp.err.code + "): " + data.rsp.err.msg);
					}
				}
			});
		}
	}
	
	jQuery(document).ready(function () {
		applybonus();
		jQuery('select[name="elements[37d3a0c7-9446-48ff-a0a1-7476aef328b8][0][list-1]"]').change(function(){
			applybonus();
		});
		jQuery('select[name="elements[fe492a91-951e-4e06-9054-3df8af796f8a][option][]"]').change(function(){
			applyems(weight);
		});
	});
</script>